OGRE: Ogre::InstancedEntity Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::InstancedEntity Class Reference
Core » Scene

`#include <OgreInstancedEntity.h>`

Inheritance diagram for Ogre::InstancedEntity:
[legend]

## Public Member Functions
| InstancedEntity (InstanceBatch *batchOwner, uint32 instanceID, InstancedEntity *sharedTransformEntity=NULL)
virtual | ~InstancedEntity ()
const Vector3 & | _getDerivedPosition () const
| Returns the derived position of the instanced entity including local transform.
InstanceBatch * | _getOwner () const
const Affine3 & | _getParentNodeFullTransform (void) const override
| Returns the world transform of the instanced entity including local transform.
void | _notifyAttached (Node *parent, bool isTagPoint=false) override
| Internal method called to notify the object that it has been attached to a node.
void | _notifyMoved (void) override
| Overridden so we can tell the InstanceBatch it needs to update it's bounds.
virtual bool | _updateAnimation (void)
| Called by InstanceBatch in his _updateRenderQueue to tell us we need to calculate our bone matrices.
void | _updateRenderQueue (RenderQueue *queue) override
| Do nothing, InstanceBatch takes care of this.
AnimationStateSet * | getAllAnimationStates (void) const
AnimationState * | getAnimationState (const String &name) const
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
const Vector4f & | getCustomParam (unsigned char idx)
Real | getMaxScaleCoef () const
| Returns the maximum derived scale coefficient among the xyz values.
const String & | getMovableType (void) const override
| Returns the type name of this object.
const Quaternion & | getOrientation () const
| Retrieve the orientation.
const Vector3 & | getPosition () const
| Retrieve the position.
const Vector3 & | getScale () const
| Retrieve the local scale.
SkeletonInstance * | getSkeleton (void) const
Real | getSquaredViewDepth (const Camera *cam) const
| This is used by our batch owner to get the closest entity's depth, returns infinity when not attached to a scene node.
bool | hasSkeleton (void) const
bool | isInScene (void) const override
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isInUse () const
| Tells if the entity is in use.
void | setCustomParam (unsigned char idx, const Vector4f &newParam)
| Sets the custom parameter for this instance.
void | setInUse (bool used)
| Sets whether the entity is in use.
void | setOrientation (const Quaternion &orientation, bool doUpdate=true)
| Set the orientation or the offset from the parent node if a parent node exists.
void | setPosition (const Vector3 &position, bool doUpdate=true)
| Set the position or the offset from the parent node if a parent node exists.
void | setScale (const Vector3 &scale, bool doUpdate=true)
| Set the scale or the offset from the parent node if a parent node exists.
void | setTransformLookupNumber (uint16 num)
| Sets the transformation look up number.
bool | shareTransformWith (InstancedEntity *slave)
| Shares the entire transformation with another InstancedEntity.
void | stopSharingTransform ()
void | updateTransforms ()
| Update the world transform and derived values.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Additional Inherited Members
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

See also
  InstanceBatch to understand how instancing works.

Instanced entities work in a very similar way as how an Entity works, as this interface tries to mimic it as most as possible to make the transition between Entity and InstancedEntity as straightforward and simple as possible. There are a couple inherent limitations, for example setRenderQueueGroup only works on the InstanceBatch level, not the individual instance. This limits Z sorting for alpha blending quite significantly An InstancedEntity won't appear in scene until a SceneNode is attached to them. Once the InstancedEntity is no longer needed, call InstanceBatch::removeInstancedEntity to put them back into a queue so the batch can return it back again when a new instance is requested.

  Internally, instanced entities that are not visible (i.e. by setting setVisible(false) or when they don't have a SceneNode attached to them) a Zero world matrix is sent to the vertex shader which in turn causes a zero area triangle. This obviously means no Vertex shader benefit, but saves a bit of pixel shader processing power. Also this means this object won't be considered when sizing the InstanceBatch's bounding box.

  Each instance has an instance ID unique within the batch, which matches the ID sent to the vertex shader by some techniques (like InstanceBatchShader).

  Differences between Entity and InstancedEntity: Setting RenderQueueGroup and other Renderable stuff works at InstanceBatch level, not InstancedEntity. This is obviously a limitation from instancing in general, not this particular implementation

Author
  Matias N. Goldberg ("dark_sylinc")

The documentation for this class was generated from the following file:

- OgreInstancedEntity.h